!================================================================
       subroutine inertia(lpr)
!-------------------------------------------
!     This subroutine is to calculate the
!     moment of inertia base on the Inglis-Belyaev formula
!----------------------------------------------------------------
!Use Definitions
!Use MeanField
c      Implicit None
!
      implicit real*8 (a-h,o-z)
c
      include 'dirhb.par'

      Logical lpr
      Integer it,ib,k1,k2,k,l,ifg,ndsp,i0sp,nfgsp,m1,m2,ibsp
      Integer nr1,nl1,nj1,nm1,nr2,nl2,nj2,nm2,nm2r
      Real*8 ormsphfg(nkx,nbx,2), fgs(nh2x,nkx,4) ! nh2x = nt2x 
      Real*8 hfnm1,hfnm2,hfnj1,hfnj2
      Real*8 eqpk,eqpl
      Real*8 vk,vl,uk,ul
      real*8 inerx,iner1,iner2
!                                                                                     
      Real*8 amx11,amx,ctemp1x,ctemp2x,amx21
!
      common /fermi / ala(2),tz(2)
      common/basesph1/nljm(nt2x,4),idsp(2,2),iasp(2,2)
      common /basesph2/ fgsph(nh2x,nkx,4),kasp(nbx,4),kdsp(nbx,4)
      common /basesph3/ vvs(nkx,4),ees(nkx,4),delss(nkx,4),
     & fss(nkx,4),eqps(nkx,4)
      common /mathco/ zero,one,two,half,third,pi
      common /gfviv / iv(-IGFV:IGFV)
      common /gfvsq / sq(0:IGFV)
      common /kblock/ kblocs(2)
      common /inert/ inerx
!=========================================================
!----------------The expectation value OF J^2_z--------------------------
       inerx = zero
       iner1 = zero
       iner2 = zero
!---------- loop over neutrons and protons
       do it = 1,2
!---- loop over simplex-parity-blocks
         do ibsp = 1,2
        k1 = kasp(ibsp,it) + 1
        k2 = kasp(ibsp,it) + kdsp(ibsp,it)
c           write(*,*)'k',k1,k2
!----------determine the number of unoccupied states in the block (ib,it)--------
        do k = k1,k2
           if(k.eq.kblocs(it)) goto 140 
        do l = k1,k2
           if(l.eq.kblocs(it)) goto 120
           if(vvs(k,it).lt.1.0d-10.and.vvs(l,it).lt.1.0d-10) goto 120
!--------Initialization of the matrix elements----------------------
        amx11=zero
!------- loop over contributions from large and small components
           do ifg = 1,2
              ndsp  = idsp(ibsp,ifg)
              i0sp  = iasp(ibsp,ifg)
              nfgsp = (ifg-1)*idsp(ibsp,1)
!---------- loop of spher. oscillator basis----------
	      do m1=1,ndsp
                 if(fgsph(nfgsp+m1,k,it).eq.0) goto 130
              do m2=1,ndsp 
                 nr1 = nljm(i0sp+m1,1)
                 nl1 = nljm(i0sp+m1,2)
                 nj1 = nljm(i0sp+m1,3)
                 nm1 = nljm(i0sp+m1,4)
                 nr2 = nljm(i0sp+m2,1)
                 nl2 = nljm(i0sp+m2,2)
                 nj2 = nljm(i0sp+m2,3)
                 nm2 = nljm(i0sp+m2,4)
!---------time Resersal states of m2--------
                 nm2r= 1-nm2
!---------------------------------
                 if(nr1.ne.nr2) goto 110
                 if(nl1.ne.nl2) goto 110
                 if(nj1.ne.nj2) goto 110
!----------m=M-1/2---------------------------
                 hfnm1 =nm1-half
                 hfnm2 =nm2-half
                 hfnj1 =nj1-half 
                 hfnj2 =nj2-half
!----------------------------------------------------------------------                 
                 ctemp1x=zero
                 if(nm1-1.eq.nm2) then
                 ctemp1x=fgsph(nfgsp+m1,k,it)*fgsph(nfgsp+m2,l,it)
     & *half*sq((nj2-nm2)*(nj2+nm2))
                 endif
                 if(nm1+1.eq.nm2) then
                 ctemp1x=fgsph(nfgsp+m1,k,it)*fgsph(nfgsp+m2,l,it)
     & *half*sq((nj2+nm2-1)*(nj2-nm2+1))
                 endif
!-----------------------------------------------------------------------
                 ctemp2x=zero
                 if(nm1-1.eq.nm2r) then
                 ctemp2x= iv(nl2+nj2-nm2)*iv(ifg-1) 
     & *fgsph(nfgsp+m1,k,it)*fgsph(nfgsp+m2,l,it)
     & *half*sq((nj2-nm2r)*(nj2+nm2r))
                 endif
!                 if(nm1+1.eq.nm2r) then
!                 ctemp2x= iv(nl2+nj2-nm2)*iv(ifg-1)  &
!                  & *fgsph(nfgsp+m1,k,it)*fgsph(nfgsp+m2,l,it)*half*sq((nj2r+nm2r-1)*(nj2r-nm2r+1))
!                 endif
!----------------------------------------------------------------
                 amx11= amx11+ctemp1x+ctemp2x
!----------------------------------------------------------------
  110           enddo !m2
  130           enddo !m1
           enddo !ifg
!--------------------------------------------------
        amx=amx11**2
c        write(*,*)'amx',amx
!----- contribution from pairing part
        vk=dsqrt(vvs(k,it))  
        vl=dsqrt(vvs(l,it))  
        uk=dsqrt(one-vvs(k,it))  
        ul=dsqrt(one-vvs(l,it))  
!-----------------------------------
	eqpk=eqps(k,it)
	eqpl=eqps(l,it)
        inerx=inerx+2*(uk*vl-vk*ul)**2/(eqpk+eqpl)*amx
        iner1=iner1+2*(uk*vl-vk*ul)**2/(eqpk+eqpl)*amx
c        write(*,*)'inerx',inerx,iner1
!-------------------------------------------------
  120        enddo !l
  140        enddo !k
!        write(*,*) 'inerx=',inerx
       enddo !ib
!-----------second term for odd system-----------------------
       if(kblocs(it).ne.0) then
!---- loop over simplex-parity-blocks
       do ibsp = 1,2
        k1 = kasp(ibsp,it) + 1
        k2 = kasp(ibsp,it) + kdsp(ibsp,it)
!----------determine the number of unoccupied states in the block (ib,it)--------
        do k = k1,k2
           if(k.eq.kblocs(it)) goto 240
!--------Initialization of the matrix elements----------------------
           amx21=zero
!------- loop over contributions from large and small components
           do ifg = 1,2
              ndsp  = idsp(ibsp,ifg)
              i0sp  = iasp(ibsp,ifg)
              nfgsp = (ifg-1)*idsp(ibsp,1)
!---------- loop of spher. oscillator basis----------
              do m1=1,ndsp
                 if(fgsph(nfgsp+m1,k,it).eq.0) goto 230
              do m2=1,ndsp 
                 nr1 = nljm(i0sp+m1,1)
                 nl1 = nljm(i0sp+m1,2)
                 nj1 = nljm(i0sp+m1,3)
                 nm1 = nljm(i0sp+m1,4)
                 nr2 = nljm(i0sp+m2,1)
                 nl2 = nljm(i0sp+m2,2)
                 nj2 = nljm(i0sp+m2,3)
                 nm2 = nljm(i0sp+m2,4)
!---------time Resersal states of m2--------
                 nm2r= 1-nm2
!---------------------------------
                 if(nr1.ne.nr2) goto 210
                 if(nl1.ne.nl2) goto 210
                 if(nj1.ne.nj2) goto 210
!----------m=M-1/2---------------------------
                 hfnm1 =nm1-half
                 hfnm2 =nm2-half
                 hfnj1 =nj1-half
                 hfnj2 =nj2-half
!----------------------------------------------------------------------
                 ctemp1x=zero
                 if(nm1-1.eq.nm2) then
                 ctemp1x=fgsph(nfgsp+m1,k,it)*
     & fgsph(nfgsp+m2,kblocs(it),it)*half*sq((nj2-nm2)*(nj2+nm2))
                 endif
                 if(nm1+1.eq.nm2) then
                 ctemp1x=fgsph(nfgsp+m1,k,it)*
     & fgsph(nfgsp+m2,kblocs(it),it)*half*sq((nj2+nm2-1)*(nj2-nm2+1))
                 endif
!-----------------------------------------------------------------------
                 ctemp2x=zero
!                 if(nm1-1.eq.nm2r) then
!                 ctemp2x= iv(nl2+nj2-nm2)*iv(ifg-1) &
!                  & *fgsph(nfgsp+m1,k,it)*fgsph(nfgsp+m2,kblocs(it),it)*half*sq((nj2-nm2r)*(nj2+nm2r))
!                 endif
!                 if(nm1+1.eq.nm2r) then
!                 ctemp2x= iv(nl2+nj2-nm2)*iv(ifg-1)  &
!                  & *fgsph(nfgsp+m1,k,it)*fgsph(nfgsp+m2,l,it)*half*sq((nj2r+nm2r-1)*(nj2r-nm2r+1))
!                 endif
!----------------------------------------------------------------
                 amx21= amx21+ctemp1x+ctemp2x
!----------------------------------------------------------------
210           enddo !m2
230           enddo !m1
           enddo !ifg  
!--------------------------------------------------
        amx=amx21**2
!----- contribution from pairing part
        vk=dsqrt(vvs(k,it))  
        vl=dsqrt(vvs(kblocs(it),it))  
        uk=dsqrt(one-vvs(k,it))
        ul=dsqrt(one-vvs(kblocs(it),it))  
!-----------------------------------
        eqpk=eqps(k,it)
        eqpl=eqps(kblocs(it),it)
        if((eqpk-eqpl).lt.0)   
     &  print *, ees(kblocs(it),it), ala(it), k, ees(k,it)
!        print *, k,eqpk,kblocs(it), eqpl, amx
        inerx=inerx+2*(uk*ul+vk*vl)**2/(eqpk-eqpl)*amx
        iner2=iner2+2*(uk*ul+vk*vl)**2/(eqpk-eqpl)*amx
!-------------------------------------------------
  240        enddo !k
!        write(*,*) 'iner=',inerx  
       enddo !ib
       endif
       enddo !it
!----------------------
!------------------------------------------------------------------
      write(*,*) '<I_x>=',inerx
!---------------------------    
!-END-ANGULAR
      END
