!================================================================
       subroutine rotation(lpr)
!-------------------------------------------
!     This subroutine is to calculate the
!     expectation value of J^2 of the g.s.
!----------------------------------------------------------------
!Use Definitions
!Use MeanField
c      Implicit None

      implicit real*8 (a-h,o-z)
c
      include 'dirhb.par'
      Logical lpr
      Integer it,ib,k1,k2,k,l,ifg,ndsp,i0sp,nfgsp,m1,m2,ibsp
      Integer nr1,nl1,nj1,nm1,nr2,nl2,nj2,nm2,nr2r,nl2r,nj2r,nm2r
      Real*8 ormsphfg(nkx,nbx,2), fgs(nh2x,nkx,4) ! nh2x = nt2x 
      Real*8 hfnm1,hfnm2,hfnm2r,hfnj1,hfnj2,hfnj2r
      Real*8 angkkz,angklz,angkkx,angklx
      Real*8 vk,vl,uk,ul
!                                                                                     
!COMPLEX(dp) :: ctemp1y,ctemp2y,amy11,amy12,amy21,amy22,angmomy2,angkly,angkky
!Real(dp) :: amz11,amz12,amz21,amz22,ctemp1z,ctemp2z,angmomz2
      Real*8 amx11,amx12,amx21,amx22,ctemp1x,ctemp2x

      common/basesph1/nljm(nt2x,4),idsp(2,2),iasp(2,2)
      common /basesph2/ fgsph(nh2x,nkx,4),kasp(nbx,4),kdsp(nbx,4)
      common /basesph3/ vvs(nkx,4),ees(nkx,4),delss(nkx,4),
     & fss(nkx,4),eqps(nkx,4)
      common /mathco/ zero,one,two,half,third,pi
      common /gfviv / iv(-IGFV:IGFV)
      common /gfvsq / sq(0:IGFV)
      common /moment/ angmomx2
!
!=========================================================
!open(36,file='matr1.out',form='formatted',status='unknown')
!open(37,file='matr2.out',form='formatted',status='unknown')
!----------------The expectation value OF J^2_z--------------------------
! angmomz2 = zero; angkkz   = zero; angklz   = zero
! angkky   = zero; angkly   = zero; angmomy2 = zero
       angkkx   = zero 
       angklx   = zero 
       angmomx2 = zero
!---------- loop over neutrons and protons
       do it = 1,2
!---- loop over simplex-parity-blocks
       do ibsp = 1,2
        k1 = kasp(ibsp,it) + 1
        k2 = kasp(ibsp,it) + kdsp(ibsp,it)
!----------determine the number of unoccupied states in the block (ib,it)--------
        do k = k1,k2
           if(vvs(k,it).lt.1.d-10) goto 120
        do l = k1,k2
!--------Initialization of the matrix elements----------------------
!        amz11=zero; amz12=zero
!        amy11=zero; amy12=zero
        amx11=zero
        amx12=zero
!------- loop over contributions from large and small components
           do ifg = 1,2
              ndsp  = idsp(ibsp,ifg)
              i0sp  = iasp(ibsp,ifg)
              nfgsp = (ifg-1)*idsp(ibsp,1)
!---------- loop of spher. oscillator basis----------
	      do m1=1,ndsp
                 if(fgsph(nfgsp+m1,k,it).eq.0) goto 130
              do m2=1,ndsp 
                 nr1 = nljm(i0sp+m1,1)
                 nl1 = nljm(i0sp+m1,2)
                 nj1 = nljm(i0sp+m1,3)
                 nm1 = nljm(i0sp+m1,4)
                 nr2 = nljm(i0sp+m2,1)
                 nl2 = nljm(i0sp+m2,2)
                 nj2 = nljm(i0sp+m2,3)
                 nm2 = nljm(i0sp+m2,4)
!---------time Resersal states of m2--------
                 nr2r= nr2
                 nl2r= nl2
                 nj2r= nj2
                 nm2r= 1-nm2
!---------------------------------
                 if(nr1.ne.nr2) goto 110
                 if(nl1.ne.nl2) goto 110
                 if(nj1.ne.nj2) goto 110
!----------m=M-1/2---------------------------
                 hfnm1 =nm1-half
                 hfnm2 =nm2-half
                 hfnj1 =nj1-half 
                 hfnj2 =nj2-half
                 hfnm2r=nm2r-half
                 hfnj2r=hfnj2 
!----------------------------------------------------------------------                
!                  ctemp1z=zero; ctemp2z=zero 
!                  ctemp1y=zero; ctemp2y=zero 
                  ctemp1x=zero 
                  ctemp2x=zero
!                 if(nm1.eq.nm2) then
!                 ctemp1z = fgsph(nfgsp+m1,k,it)*fgsph(nfgsp+m2,l,it)*hfnm1
!                 endif
                 if(nm1-1.eq.nm2) then
!                 ctemp1y=fgsph(nfgsp+m1,k,it)*fgsph(nfgsp+m2,l,it)*DCMPLX(0.d0,-0.5d0)*sq((nj2-nm2)*(nj2+nm2))
                 ctemp1x=fgsph(nfgsp+m1,k,it)*fgsph(nfgsp+m2,l,it)
     & *half*sq((nj2-nm2)*(nj2+nm2))
                 endif
                 if(nm1+1.eq.nm2) then
!                 ctemp1y=fgsph(nfgsp+m1,k,it)*fgsph(nfgsp+m2,l,it)*DCMPLX(0.d0,0.5d0)*sq((nj2+nm2-1)*(nj2-nm2+1))
                 ctemp1x=fgsph(nfgsp+m1,k,it)*fgsph(nfgsp+m2,l,it)
     & *half*sq((nj2+nm2-1)*(nj2-nm2+1))
                 endif
!----------------------------------------------------------------
                 if(nm1-1.eq.nm2r) then
!                 ctemp2y= iv(nl2+nj2-nm2)*iv(ifg-1) & 
!                  & *fgsph(nfgsp+m1,k,it)*fgsph(nfgsp+m2,l,it)*DCMPLX(0.d0,-0.5d0)*sq((nj2r-nm2r)*(nj2r+nm2r))
                 ctemp2x= iv(nl2+nj2-nm2)*iv(ifg-1) 
     & *fgsph(nfgsp+m1,k,it)*fgsph(nfgsp+m2,l,it)
     &*half*sq((nj2r-nm2r)*(nj2r+nm2r))
                 endif
                 if(nm1+1.eq.nm2r) then
!                 ctemp2y= iv(nl2+nj2-nm2)*iv(ifg-1)  &
!                  & *fgsph(nfgsp+m1,k,it)*fgsph(nfgsp+m2,l,it)*DCMPLX(0.d0,0.5d0)*sq((nj2r+nm2r-1)*(nj2r-nm2r+1))
                 ctemp2x= iv(nl2+nj2-nm2)*iv(ifg-1)  
     & *fgsph(nfgsp+m1,k,it)*fgsph(nfgsp+m2,l,it)*half
     & *sq((nj2r+nm2r-1)*(nj2r-nm2r+1))
                 endif
!----------------------------------------------------------------
!                 amz11= amz11+ctemp1z; amz12= amz12+ctemp2z
!                 amy11= amy11+ctemp1y; amy12= amy12+ctemp2y
                 amx11= amx11+ctemp1x
                 amx12= amx12+ctemp2x
!----------------------------------------------------------------
110           enddo !m2
130           enddo !m1
           enddo !ifg
!--------------------------------------------------
!        amz21=amz12;          amz22=-amz11
!        amy21=DCONJG(amy12);  amy22=-DCONJG(amy11)
         amx21=amx12          
         amx22=-amx11
!---------------------------
!        if(l.eq.k)   angkkz=angkkz+(amz11+amz22)*vvs(k,it)
!        if(l.eq.k)   angkky=angkky+(amy11+amy22)*vvs(k,it)
!        if(l.eq.k)   angkkx=angkkx+(amx11+amx22)*vvs(k,it)
!----- contribution from pairing part
        vk=dsqrt(vvs(k,it))  
        vl=dsqrt(vvs(l,it))  
        uk=dsqrt(one-vvs(k,it))  
        ul=dsqrt(one-vvs(l,it))  
!        angklz=angklz+2*(amz11*amz22-amz12*amz21)*vk*uk*vl*ul
!        angkly=angkly+2*(amy11*amy22-amy12*amy21)*vk*uk*vl*ul
        angklx=angklx+2*(amx11*amx22-amx12*amx21)*vk*uk*vl*ul
!-----------------------------------
!        if(abs(2*(amx11*amx22-amx12*amx21)*vk*uk*vl*ul).gt.0.001d0) then
!        write(36,600) k,l,ees(k,it),vvs(k,it),ees(l,it),vvs(l,it), &
!        & amy11, amy12, amy21, amy22, 2*Real(amx11*amx22-amx12*amx21)*vk*uk*vl*ul
!        endif
!-----------------------------------
!        amz11=amz11**2;  amz12=amz12**2;  amz21=amz21**2;  amz22=amz22**2
!        amy11=-amy11**2; amy12=-amy12**2; amy21=-amy21**2; amy22=-amy22**2
        amx11=amx11**2  
        amx12=amx12**2
        amx21=amx21**2
        amx22=amx22**2
!-----------------------------------
!        angmomz2=angmomz2+(amz11+amz12+amz21+amz22)*vvs(k,it)*(one-vvs(l,it))
!        angmomy2=angmomy2+(amy11+amy12+amy21+amy22)*vvs(k,it)*(one-vvs(l,it))
        angmomx2=angmomx2+(amx11+amx12+amx21+amx22)*
     &  vvs(k,it)*(one-vvs(l,it))
!-------------------------------------------------
!        if(abs(Real(amx11+amx12+amx21+amx22)*vvs(k,it)*(one-vvs(l,it))).gt.0.001) then
!        write(37,600) k,l,ees(k,it),vvs(k,it),ees(l,it),vvs(l,it), &
!        & amy11, amy12, amy21, amy22, Real(amy11+amy12+amy21+amy22)*vvs(k,it)*(one-vvs(l,it))
!        endif
        enddo !l
  120      enddo !k
  600  format(2i4,4f12.5,8f12.5,f12.5)
!        write(*,*) 'angmomz2=',angmomz2, 'angklz=',angklz
!        write(*,*) 'angmomy2=',angmomy2, 'angkly=',angkly
!        write(*,*) 'angmomx2=',angmomx2, 'angklx=',angklx
         enddo !ib
         enddo !it
!----------------------
!       angmomz2=angmomz2+angklz
!       angmomy2=angmomy2+angkly
       angmomx2=angmomx2+angklx
!------------------------------------------------------------------
!      write(*,*) '<J^2_z>=',angmomz2
!      write(*,*) '<J^2_y>=',angmomy2
      write(*,*) '<J^2_x>=',angmomx2
!---------------------------    
!-END-ANGULAR
       END
